--- jdk17u/src/jdk.crypto.cryptoki/share/classes/sun/security/pkcs11/SunPKCS11.java	2022-10-19 11:43:16.199128217 +0200
+++ jdk17u/src/jdk.crypto.cryptoki/share/classes/sun/security/pkcs11/SunPKCS11.java	2022-10-19 11:43:33.835267926 +0200
@@ -26,6 +26,9 @@
 package sun.security.pkcs11;
 
 import java.io.*;
+import java.lang.invoke.MethodHandle;
+import java.lang.invoke.MethodHandles;
+import java.lang.invoke.MethodType;
 import java.util.*;
 
 import java.security.*;
@@ -42,6 +45,7 @@
 
 import com.sun.crypto.provider.ChaCha20Poly1305Parameters;
 
+import jdk.internal.access.SharedSecrets;
 import jdk.internal.misc.InnocuousThread;
 import sun.security.util.Debug;
 import sun.security.util.ResourcesMgr;
@@ -62,6 +66,37 @@
  */
 public final class SunPKCS11 extends AuthProvider {
 
+    private static final boolean systemFipsEnabled = SharedSecrets
+            .getJavaSecuritySystemConfiguratorAccess().isSystemFipsEnabled();
+
+    private static final boolean plainKeySupportEnabled = SharedSecrets
+            .getJavaSecuritySystemConfiguratorAccess().isPlainKeySupportEnabled();
+
+    private static final MethodHandle fipsImportKey;
+    private static final MethodHandle fipsExportKey;
+    static {
+        MethodHandle fipsImportKeyTmp = null;
+        MethodHandle fipsExportKeyTmp = null;
+        if (plainKeySupportEnabled) {
+            try {
+                fipsImportKeyTmp = MethodHandles.lookup().findStatic(
+                        FIPSKeyImporter.class, "importKey",
+                        MethodType.methodType(Long.class, SunPKCS11.class,
+                        long.class, CK_ATTRIBUTE[].class));
+                fipsExportKeyTmp = MethodHandles.lookup().findStatic(
+                        FIPSKeyImporter.class, "exportKey",
+                        MethodType.methodType(void.class, SunPKCS11.class,
+                        long.class, long.class,
+                        long.class, long.class, Map.class));
+            } catch (Throwable t) {
+                throw new SecurityException("FIPS key importer-exporter" +
+                        " initialization failed", t);
+            }
+        }
+        fipsImportKey = fipsImportKeyTmp;
+        fipsExportKey = fipsExportKeyTmp;
+    }
+
     private static final long serialVersionUID = -1354835039035306505L;
 
     static final Debug debug = Debug.getInstance("sunpkcs11");
@@ -331,10 +366,19 @@
             // request multithreaded access first
             initArgs.flags = CKF_OS_LOCKING_OK;
             PKCS11 tmpPKCS11;
+            MethodHandle fipsKeyImporter = null;
+            MethodHandle fipsKeyExporter = null;
+            if (plainKeySupportEnabled) {
+                fipsKeyImporter = MethodHandles.insertArguments(
+                        fipsImportKey, 0, this);
+                fipsKeyExporter = MethodHandles.insertArguments(
+                        fipsExportKey, 0, this);
+            }
             try {
                 tmpPKCS11 = PKCS11.getInstance(
                     library, functionList, initArgs,
-                    config.getOmitInitialize());
+                    config.getOmitInitialize(), fipsKeyImporter,
+                    fipsKeyExporter);
             } catch (PKCS11Exception e) {
                 if (debug != null) {
                     debug.println("Multi-threaded initialization failed: " + e);
@@ -350,11 +394,12 @@
                     initArgs.flags = 0;
                 }
                 tmpPKCS11 = PKCS11.getInstance(library,
-                    functionList, initArgs, config.getOmitInitialize());
+                    functionList, initArgs, config.getOmitInitialize(), fipsKeyImporter,
+                    fipsKeyExporter);
             }
             p11 = tmpPKCS11;
 
-            CK_INFO p11Info = p11.C_GetInfo();
+            CK_INFO p11Info = p11.getInfo();
             if (p11Info.cryptokiVersion.major < 2) {
                 throw new ProviderException("Only PKCS#11 v2.0 and later "
                 + "supported, library version is v" + p11Info.cryptokiVersion);
@@ -390,6 +435,24 @@
             if (nssModule != null) {
                 nssModule.setProvider(this);
             }
+            if (systemFipsEnabled) {
+                // The NSS Software Token in FIPS 140-2 mode requires a user
+                // login for most operations. See sftk_fipsCheck. The NSS DB
+                // (/etc/pki/nssdb) PIN is empty.
+                Session session = null;
+                try {
+                    session = token.getOpSession();
+                    p11.C_Login(session.id(), CKU_USER, new char[] {});
+                } catch (PKCS11Exception p11e) {
+                    if (debug != null) {
+                        debug.println("Error during token login: " +
+                                p11e.getMessage());
+                    }
+                    throw p11e;
+                } finally {
+                    token.releaseSession(session);
+                }
+            }
         } catch (Exception e) {
             if (config.getHandleStartupErrors() == Config.ERR_IGNORE_ALL) {
                 throw new UnsupportedOperationException
@@ -428,14 +491,19 @@
         final String className;
         final List<String> aliases;
         final int[] mechanisms;
+        final int[] requiredMechs;
 
+        // mechanisms is a list of possible mechanisms that implement the
+        // algorithm, at least one of them must be available. requiredMechs
+        // is a list of auxiliary mechanisms, all of them must be available
         private Descriptor(String type, String algorithm, String className,
-                List<String> aliases, int[] mechanisms) {
+                List<String> aliases, int[] mechanisms, int[] requiredMechs) {
             this.type = type;
             this.algorithm = algorithm;
             this.className = className;
             this.aliases = aliases;
             this.mechanisms = mechanisms;
+            this.requiredMechs = requiredMechs;
         }
         private P11Service service(Token token, int mechanism) {
             return new P11Service
@@ -469,18 +537,29 @@
 
     private static void d(String type, String algorithm, String className,
             int[] m) {
-        register(new Descriptor(type, algorithm, className, null, m));
+        register(new Descriptor(type, algorithm, className, null, m, null));
     }
 
     private static void d(String type, String algorithm, String className,
             List<String> aliases, int[] m) {
-        register(new Descriptor(type, algorithm, className, aliases, m));
+        register(new Descriptor(type, algorithm, className, aliases, m, null));
+    }
+
+    private static void d(String type, String algorithm, String className,
+            int[] m, int[] requiredMechs) {
+        register(new Descriptor(type, algorithm, className, null, m,
+                requiredMechs));
+    }
+    private static void dA(String type, String algorithm, String className,
+                           int[] m, int[] requiredMechs) {
+        register(new Descriptor(type, algorithm, className,
+                getAliases(algorithm), m, requiredMechs));
     }
 
     private static void dA(String type, String algorithm, String className,
             int[] m) {
         register(new Descriptor(type, algorithm, className,
-                getAliases(algorithm), m));
+                getAliases(algorithm), m, null));
     }
 
     private static void register(Descriptor d) {
@@ -536,6 +615,7 @@
         String P11Cipher           = "sun.security.pkcs11.P11Cipher";
         String P11RSACipher        = "sun.security.pkcs11.P11RSACipher";
         String P11AEADCipher       = "sun.security.pkcs11.P11AEADCipher";
+        String P11PBECipher        = "sun.security.pkcs11.P11PBECipher";
         String P11Signature        = "sun.security.pkcs11.P11Signature";
         String P11PSSSignature     = "sun.security.pkcs11.P11PSSSignature";
 
@@ -598,6 +678,30 @@
         d(MAC, "SslMacSHA1",    P11Mac,
                 m(CKM_SSL3_SHA1_MAC));
 
+        if (systemFipsEnabled) {
+            /*
+             * PBA HMacs
+             *
+             * KeyDerivationMech must be supported
+             * for these services to be available.
+             *
+             */
+            d(MAC, "HmacPBESHA1",       P11Mac, m(CKM_SHA_1_HMAC),
+                    m(CKM_PBA_SHA1_WITH_SHA1_HMAC));
+            d(MAC, "HmacPBESHA224",     P11Mac, m(CKM_SHA224_HMAC),
+                    m(CKM_NSS_PKCS12_PBE_SHA224_HMAC_KEY_GEN));
+            d(MAC, "HmacPBESHA256",     P11Mac, m(CKM_SHA256_HMAC),
+                    m(CKM_NSS_PKCS12_PBE_SHA256_HMAC_KEY_GEN));
+            d(MAC, "HmacPBESHA384",     P11Mac, m(CKM_SHA384_HMAC),
+                    m(CKM_NSS_PKCS12_PBE_SHA384_HMAC_KEY_GEN));
+            d(MAC, "HmacPBESHA512",     P11Mac, m(CKM_SHA512_HMAC),
+                    m(CKM_NSS_PKCS12_PBE_SHA512_HMAC_KEY_GEN));
+            d(MAC, "HmacPBESHA512/224", P11Mac, m(CKM_SHA512_224_HMAC),
+                    m(CKM_NSS_PKCS12_PBE_SHA512_HMAC_KEY_GEN));
+            d(MAC, "HmacPBESHA512/256", P11Mac, m(CKM_SHA512_256_HMAC),
+                    m(CKM_NSS_PKCS12_PBE_SHA512_HMAC_KEY_GEN));
+        }
+
         d(KPG, "RSA",           P11KeyPairGenerator,
                 getAliases("PKCS1"),
                 m(CKM_RSA_PKCS_KEY_PAIR_GEN));
@@ -696,6 +800,66 @@
         d(SKF, "ChaCha20",      P11SecretKeyFactory,
                 m(CKM_CHACHA20_POLY1305));
 
+        if (systemFipsEnabled) {
+            /*
+             * PBE Secret Key Factories
+             *
+             * KeyDerivationPrf must be supported for these services
+             * to be available.
+             *
+             */
+            d(SKF, "PBEWithHmacSHA1AndAES_128",
+                    P11SecretKeyFactory, m(CKM_PKCS5_PBKD2), m(CKM_SHA_1_HMAC));
+            d(SKF, "PBEWithHmacSHA224AndAES_128",
+                    P11SecretKeyFactory, m(CKM_PKCS5_PBKD2), m(CKM_SHA224_HMAC));
+            d(SKF, "PBEWithHmacSHA256AndAES_128",
+                    P11SecretKeyFactory, m(CKM_PKCS5_PBKD2), m(CKM_SHA256_HMAC));
+            d(SKF, "PBEWithHmacSHA384AndAES_128",
+                    P11SecretKeyFactory, m(CKM_PKCS5_PBKD2), m(CKM_SHA384_HMAC));
+            d(SKF, "PBEWithHmacSHA512AndAES_128",
+                    P11SecretKeyFactory, m(CKM_PKCS5_PBKD2), m(CKM_SHA512_HMAC));
+            d(SKF, "PBEWithHmacSHA1AndAES_256",
+                    P11SecretKeyFactory, m(CKM_PKCS5_PBKD2), m(CKM_SHA_1_HMAC));
+            d(SKF, "PBEWithHmacSHA224AndAES_256",
+                    P11SecretKeyFactory, m(CKM_PKCS5_PBKD2), m(CKM_SHA224_HMAC));
+            d(SKF, "PBEWithHmacSHA256AndAES_256",
+                    P11SecretKeyFactory, m(CKM_PKCS5_PBKD2), m(CKM_SHA256_HMAC));
+            d(SKF, "PBEWithHmacSHA384AndAES_256",
+                    P11SecretKeyFactory, m(CKM_PKCS5_PBKD2), m(CKM_SHA384_HMAC));
+            d(SKF, "PBEWithHmacSHA512AndAES_256",
+                    P11SecretKeyFactory, m(CKM_PKCS5_PBKD2), m(CKM_SHA512_HMAC));
+            /*
+             * PBA Secret Key Factories
+             */
+            d(SKF, "HmacPBESHA1",       P11SecretKeyFactory,
+                    m(CKM_PBA_SHA1_WITH_SHA1_HMAC));
+            d(SKF, "HmacPBESHA224",     P11SecretKeyFactory,
+                    m(CKM_NSS_PKCS12_PBE_SHA224_HMAC_KEY_GEN));
+            d(SKF, "HmacPBESHA256",     P11SecretKeyFactory,
+                    m(CKM_NSS_PKCS12_PBE_SHA256_HMAC_KEY_GEN));
+            d(SKF, "HmacPBESHA384",     P11SecretKeyFactory,
+                    m(CKM_NSS_PKCS12_PBE_SHA384_HMAC_KEY_GEN));
+            d(SKF, "HmacPBESHA512",     P11SecretKeyFactory,
+                    m(CKM_NSS_PKCS12_PBE_SHA512_HMAC_KEY_GEN));
+            d(SKF, "HmacPBESHA512/224", P11SecretKeyFactory,
+                    m(CKM_NSS_PKCS12_PBE_SHA512_HMAC_KEY_GEN));
+            d(SKF, "HmacPBESHA512/256", P11SecretKeyFactory,
+                    m(CKM_NSS_PKCS12_PBE_SHA512_HMAC_KEY_GEN));
+            /*
+             * PBKDF2 Secret Key Factories
+             */
+            dA(SKF, "PBKDF2WithHmacSHA1",  P11SecretKeyFactory,
+                    m(CKM_PKCS5_PBKD2), m(CKM_SHA_1_HMAC));
+            d(SKF, "PBKDF2WithHmacSHA224", P11SecretKeyFactory,
+                    m(CKM_PKCS5_PBKD2), m(CKM_SHA224_HMAC));
+            d(SKF, "PBKDF2WithHmacSHA256", P11SecretKeyFactory,
+                    m(CKM_PKCS5_PBKD2), m(CKM_SHA256_HMAC));
+            d(SKF, "PBKDF2WithHmacSHA384", P11SecretKeyFactory,
+                    m(CKM_PKCS5_PBKD2), m(CKM_SHA384_HMAC));
+            d(SKF, "PBKDF2WithHmacSHA512", P11SecretKeyFactory,
+                    m(CKM_PKCS5_PBKD2), m(CKM_SHA512_HMAC));
+        }
+
         // XXX attributes for Ciphers (supported modes, padding)
         dA(CIP, "ARCFOUR",                      P11Cipher,
                 m(CKM_RC4));
@@ -765,6 +929,46 @@
         d(CIP, "RSA/ECB/NoPadding",             P11RSACipher,
                 m(CKM_RSA_X_509));
 
+        if (systemFipsEnabled) {
+            /*
+             * PBE Ciphers
+             *
+             * KeyDerivationMech and KeyDerivationPrf must be supported
+             * for these services to be available.
+             *
+             */
+            d(CIP, "PBEWithHmacSHA1AndAES_128",   P11PBECipher,
+                    m(CKM_AES_CBC_PAD, CKM_AES_CBC),
+                    m(CKM_PKCS5_PBKD2, CKM_SHA_1_HMAC));
+            d(CIP, "PBEWithHmacSHA224AndAES_128", P11PBECipher,
+                    m(CKM_AES_CBC_PAD, CKM_AES_CBC),
+                    m(CKM_PKCS5_PBKD2, CKM_SHA224_HMAC));
+            d(CIP, "PBEWithHmacSHA256AndAES_128", P11PBECipher,
+                    m(CKM_AES_CBC_PAD, CKM_AES_CBC),
+                    m(CKM_PKCS5_PBKD2, CKM_SHA256_HMAC));
+            d(CIP, "PBEWithHmacSHA384AndAES_128", P11PBECipher,
+                    m(CKM_AES_CBC_PAD, CKM_AES_CBC),
+                    m(CKM_PKCS5_PBKD2, CKM_SHA384_HMAC));
+            d(CIP, "PBEWithHmacSHA512AndAES_128", P11PBECipher,
+                    m(CKM_AES_CBC_PAD, CKM_AES_CBC),
+                    m(CKM_PKCS5_PBKD2, CKM_SHA512_HMAC));
+            d(CIP, "PBEWithHmacSHA1AndAES_256",   P11PBECipher,
+                    m(CKM_AES_CBC_PAD, CKM_AES_CBC),
+                    m(CKM_PKCS5_PBKD2, CKM_SHA_1_HMAC));
+            d(CIP, "PBEWithHmacSHA224AndAES_256", P11PBECipher,
+                    m(CKM_AES_CBC_PAD, CKM_AES_CBC),
+                    m(CKM_PKCS5_PBKD2, CKM_SHA224_HMAC));
+            d(CIP, "PBEWithHmacSHA256AndAES_256", P11PBECipher,
+                    m(CKM_AES_CBC_PAD, CKM_AES_CBC),
+                    m(CKM_PKCS5_PBKD2, CKM_SHA256_HMAC));
+            d(CIP, "PBEWithHmacSHA384AndAES_256", P11PBECipher,
+                    m(CKM_AES_CBC_PAD, CKM_AES_CBC),
+                    m(CKM_PKCS5_PBKD2, CKM_SHA384_HMAC));
+            d(CIP, "PBEWithHmacSHA512AndAES_256", P11PBECipher,
+                    m(CKM_AES_CBC_PAD, CKM_AES_CBC),
+                    m(CKM_PKCS5_PBKD2, CKM_SHA512_HMAC));
+        }
+
         d(SIG, "RawDSA",        P11Signature,
                 List.of("NONEwithDSA"),
                 m(CKM_DSA));
@@ -1155,9 +1359,21 @@
             if (ds == null) {
                 continue;
             }
+            descLoop:
             for (Descriptor d : ds) {
                 Integer oldMech = supportedAlgs.get(d);
                 if (oldMech == null) {
+                    if (d.requiredMechs != null) {
+                        // Check that other mechanisms required for the
+                        // service are supported before listing it as
+                        // available for the first time.
+                        for (int requiredMech : d.requiredMechs) {
+                            if (token.getMechanismInfo(
+                                    requiredMech & 0xFFFFFFFFL) == null) {
+                                continue descLoop;
+                            }
+                        }
+                    }
                     supportedAlgs.put(d, integerMech);
                     continue;
                 }
@@ -1255,6 +1471,8 @@
                 } else if (algorithm.endsWith("GCM/NoPadding") ||
                            algorithm.startsWith("ChaCha20-Poly1305")) {
                     return new P11AEADCipher(token, algorithm, mechanism);
+                } else if (algorithm.startsWith("PBE")) {
+                    return new P11PBECipher(token, algorithm, mechanism);
                 } else {
                     return new P11Cipher(token, algorithm, mechanism);
                 }
--- jdk17u/src/jdk.crypto.cryptoki/share/classes/sun/security/pkcs11/wrapper/CK_ECDH1_DERIVE_PARAMS.java	2022-10-19 11:43:16.199128217 +0200
+++ jdk17u/src/jdk.crypto.cryptoki/share/classes/sun/security/pkcs11/wrapper/CK_ECDH1_DERIVE_PARAMS.java	2022-10-19 11:43:33.835267926 +0200
@@ -100,9 +100,9 @@
     }
 
     /**
-     * Returns the string representation of CK_PKCS5_PBKD2_PARAMS.
+     * Returns the string representation of CK_ECDH1_DERIVE_PARAMS.
      *
-     * @return the string representation of CK_PKCS5_PBKD2_PARAMS
+     * @return the string representation of CK_ECDH1_DERIVE_PARAMS
      */
     public String toString() {
         StringBuilder sb = new StringBuilder();
--- jdk17u/src/jdk.crypto.cryptoki/share/classes/sun/security/pkcs11/wrapper/CK_MECHANISM.java	2022-10-19 11:43:16.199128217 +0200
+++ jdk17u/src/jdk.crypto.cryptoki/share/classes/sun/security/pkcs11/wrapper/CK_MECHANISM.java	2022-10-19 11:43:33.835267926 +0200
@@ -160,6 +160,18 @@
         init(mechanism, params);
     }
 
+    public CK_MECHANISM(long mechanism, CK_PBE_PARAMS params) {
+        init(mechanism, params);
+    }
+
+    public CK_MECHANISM(long mechanism, CK_PKCS5_PBKD2_PARAMS params) {
+        init(mechanism, params);
+    }
+
+    public CK_MECHANISM(long mechanism, CK_PKCS5_PBKD2_PARAMS2 params) {
+        init(mechanism, params);
+    }
+
     // For PSS. the parameter may be set multiple times, use the
     // CK_MECHANISM(long) constructor and setParameter(CK_RSA_PKCS_PSS_PARAMS)
     // methods instead of creating yet another constructor
--- jdk17u/src/jdk.crypto.cryptoki/share/classes/sun/security/pkcs11/wrapper/CK_PBE_PARAMS.java	2022-10-19 11:43:16.199128217 +0200
+++ jdk17u/src/jdk.crypto.cryptoki/share/classes/sun/security/pkcs11/wrapper/CK_PBE_PARAMS.java	2022-10-19 11:43:33.835267926 +0200
@@ -50,15 +50,15 @@
 
 
 /**
- * class CK_PBE_PARAMS provides all of the necessary information required byte
+ * class CK_PBE_PARAMS provides all the necessary information required by
  * the CKM_PBE mechanisms and the CKM_PBA_SHA1_WITH_SHA1_HMAC mechanism.<p>
  * <B>PKCS#11 structure:</B>
  * <PRE>
  * typedef struct CK_PBE_PARAMS {
- *   CK_CHAR_PTR pInitVector;
- *   CK_CHAR_PTR pPassword;
+ *   CK_BYTE_PTR pInitVector;
+ *   CK_UTF8CHAR_PTR pPassword;
  *   CK_ULONG ulPasswordLen;
- *   CK_CHAR_PTR pSalt;
+ *   CK_BYTE_PTR pSalt;
  *   CK_ULONG ulSaltLen;
  *   CK_ULONG ulIteration;
  * } CK_PBE_PARAMS;
@@ -72,15 +72,15 @@
     /**
      * <B>PKCS#11:</B>
      * <PRE>
-     *   CK_CHAR_PTR pInitVector;
+     *   CK_BYTE_PTR pInitVector;
      * </PRE>
      */
-    public char[] pInitVector;
+    public byte[] pInitVector;
 
     /**
      * <B>PKCS#11:</B>
      * <PRE>
-     *   CK_CHAR_PTR pPassword;
+     *   CK_UTF8CHAR_PTR pPassword;
      *   CK_ULONG ulPasswordLen;
      * </PRE>
      */
@@ -89,11 +89,11 @@
     /**
      * <B>PKCS#11:</B>
      * <PRE>
-     *   CK_CHAR_PTR pSalt
+     *   CK_BYTE_PTR pSalt
      *   CK_ULONG ulSaltLen;
      * </PRE>
      */
-    public char[] pSalt;
+    public byte[] pSalt;
 
     /**
      * <B>PKCS#11:</B>
@@ -103,6 +103,12 @@
      */
     public long ulIteration;
 
+    public CK_PBE_PARAMS(char[] pPassword, byte[] pSalt, long ulIteration) {
+         this.pPassword = pPassword;
+         this.pSalt = pSalt;
+         this.ulIteration = ulIteration;
+     }
+
     /**
      * Returns the string representation of CK_PBE_PARAMS.
      *
--- jdk17u/src/jdk.crypto.cryptoki/share/classes/sun/security/pkcs11/wrapper/CK_PKCS5_PBKD2_PARAMS2.java	1970-01-01 01:00:00.000000000 +0100
+++ jdk17u/src/jdk.crypto.cryptoki/share/classes/sun/security/pkcs11/wrapper/CK_PKCS5_PBKD2_PARAMS2.java	2022-10-19 11:43:33.835267926 +0200
@@ -0,0 +1,156 @@
+/*
+ * Copyright (c) 2022, Red Hat, Inc.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.  Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+package sun.security.pkcs11.wrapper;
+
+import static sun.security.pkcs11.wrapper.PKCS11Constants.*;
+
+/**
+ * class CK_PKCS5_PBKD2_PARAMS2 provides the parameters to the CKM_PKCS5_PBKD2
+ * mechanism.<p>
+ * <b>PKCS#11 structure:</b>
+ * <pre>
+ * typedef struct CK_PKCS5_PBKD2_PARAMS2 {
+ *   CK_PKCS5_PBKDF2_SALT_SOURCE_TYPE saltSource;
+ *   CK_VOID_PTR pSaltSourceData;
+ *   CK_ULONG ulSaltSourceDataLen;
+ *   CK_ULONG iterations;
+ *   CK_PKCS5_PBKD2_PSEUDO_RANDOM_FUNCTION_TYPE prf;
+ *   CK_VOID_PTR pPrfData;
+ *   CK_ULONG ulPrfDataLen;
+ *   CK_UTF8CHAR_PTR pPassword;
+ *   CK_ULONG ulPasswordLen;
+ * } CK_PKCS5_PBKD2_PARAMS2;
+ * </pre>
+ *
+ */
+public class CK_PKCS5_PBKD2_PARAMS2 {
+
+    /**
+     * <b>PKCS#11:</b>
+     * <pre>
+     *   CK_PKCS5_PBKDF2_SALT_SOURCE_TYPE saltSource;
+     * </pre>
+     */
+    public long saltSource;
+
+    /**
+     * <b>PKCS#11:</b>
+     * <pre>
+     *   CK_VOID_PTR pSaltSourceData;
+     *   CK_ULONG ulSaltSourceDataLen;
+     * </pre>
+     */
+    public byte[] pSaltSourceData;
+
+    /**
+     * <b>PKCS#11:</b>
+     * <pre>
+     *   CK_ULONG iterations;
+     * </pre>
+     */
+    public long iterations;
+
+    /**
+     * <b>PKCS#11:</b>
+     * <pre>
+     *   CK_PKCS5_PBKD2_PSEUDO_RANDOM_FUNCTION_TYPE prf;
+     * </pre>
+     */
+    public long prf;
+
+    /**
+     * <b>PKCS#11:</b>
+     * <pre>
+     *   CK_VOID_PTR pPrfData;
+     *   CK_ULONG ulPrfDataLen;
+     * </pre>
+     */
+    public byte[] pPrfData;
+
+    /**
+     * <b>PKCS#11:</b>
+     * <pre>
+     *   CK_UTF8CHAR_PTR pPassword
+     *   CK_ULONG ulPasswordLen;
+     * </pre>
+     */
+    public char[] pPassword;
+
+    public CK_PKCS5_PBKD2_PARAMS2(char[] pPassword, byte[] pSalt,
+            long iterations, long prf) {
+        this.pPassword = pPassword;
+        this.pSaltSourceData = pSalt;
+        this.iterations = iterations;
+        this.prf = prf;
+        this.saltSource = CKZ_SALT_SPECIFIED;
+    }
+
+    /**
+     * Returns the string representation of CK_PKCS5_PBKD2_PARAMS2.
+     *
+     * @return the string representation of CK_PKCS5_PBKD2_PARAMS2
+     */
+    public String toString() {
+        StringBuilder sb = new StringBuilder();
+
+        sb.append(Constants.INDENT);
+        sb.append("saltSource: ");
+        sb.append(saltSource);
+        sb.append(Constants.NEWLINE);
+
+        sb.append(Constants.INDENT);
+        sb.append("pSaltSourceData: ");
+        sb.append(Functions.toHexString(pSaltSourceData));
+        sb.append(Constants.NEWLINE);
+
+        sb.append(Constants.INDENT);
+        sb.append("ulSaltSourceDataLen: ");
+        sb.append(pSaltSourceData.length);
+        sb.append(Constants.NEWLINE);
+
+        sb.append(Constants.INDENT);
+        sb.append("iterations: ");
+        sb.append(iterations);
+        sb.append(Constants.NEWLINE);
+
+        sb.append(Constants.INDENT);
+        sb.append("prf: ");
+        sb.append(prf);
+        sb.append(Constants.NEWLINE);
+
+        sb.append(Constants.INDENT);
+        sb.append("pPrfData: ");
+        sb.append(Functions.toHexString(pPrfData));
+        sb.append(Constants.NEWLINE);
+
+        sb.append(Constants.INDENT);
+        sb.append("ulPrfDataLen: ");
+        sb.append(pPrfData.length);
+
+        return sb.toString();
+    }
+
+}
--- jdk17u/src/jdk.crypto.cryptoki/share/classes/sun/security/pkcs11/wrapper/CK_PKCS5_PBKD2_PARAMS.java	2022-10-19 11:43:16.199128217 +0200
+++ jdk17u/src/jdk.crypto.cryptoki/share/classes/sun/security/pkcs11/wrapper/CK_PKCS5_PBKD2_PARAMS.java	2022-10-19 11:43:33.835267926 +0200
@@ -47,7 +47,7 @@
 
 package sun.security.pkcs11.wrapper;
 
-
+import static sun.security.pkcs11.wrapper.PKCS11Constants.*;
 
 /**
  * class CK_PKCS5_PBKD2_PARAMS provides the parameters to the CKM_PKCS5_PBKD2
@@ -55,13 +55,15 @@
  * <B>PKCS#11 structure:</B>
  * <PRE>
  * typedef struct CK_PKCS5_PBKD2_PARAMS {
- *   CK_PKCS5_PBKD2_SALT_SOURCE_TYPE saltSource;
+ *   CK_PKCS5_PBKDF2_SALT_SOURCE_TYPE saltSource;
  *   CK_VOID_PTR pSaltSourceData;
  *   CK_ULONG ulSaltSourceDataLen;
  *   CK_ULONG iterations;
  *   CK_PKCS5_PBKD2_PSEUDO_RANDOM_FUNCTION_TYPE prf;
  *   CK_VOID_PTR pPrfData;
  *   CK_ULONG ulPrfDataLen;
+ *   CK_UTF8CHAR_PTR pPassword;
+ *   CK_ULONG_PTR ulPasswordLen;
  * } CK_PKCS5_PBKD2_PARAMS;
  * </PRE>
  *
@@ -113,6 +115,24 @@
     public byte[] pPrfData;
 
     /**
+     * <b>PKCS#11:</b>
+     * <pre>
+     *   CK_UTF8CHAR_PTR pPassword
+     *   CK_ULONG_PTR ulPasswordLen;
+     * </pre>
+     */
+    public char[] pPassword;
+
+    public CK_PKCS5_PBKD2_PARAMS(char[] pPassword, byte[] pSalt,
+            long iterations, long prf) {
+        this.pPassword = pPassword;
+        this.pSaltSourceData = pSalt;
+        this.iterations = iterations;
+        this.prf = prf;
+        this.saltSource = CKZ_SALT_SPECIFIED;
+    }
+
+    /**
      * Returns the string representation of CK_PKCS5_PBKD2_PARAMS.
      *
      * @return the string representation of CK_PKCS5_PBKD2_PARAMS
--- jdk17u/src/jdk.crypto.cryptoki/share/classes/sun/security/pkcs11/wrapper/CK_X9_42_DH1_DERIVE_PARAMS.java	2022-10-19 11:43:16.203128248 +0200
+++ jdk17u/src/jdk.crypto.cryptoki/share/classes/sun/security/pkcs11/wrapper/CK_X9_42_DH1_DERIVE_PARAMS.java	2022-10-19 11:43:33.835267926 +0200
@@ -94,9 +94,9 @@
     public byte[] pPublicData;
 
     /**
-     * Returns the string representation of CK_PKCS5_PBKD2_PARAMS.
+     * Returns the string representation of CK_X9_42_DH1_DERIVE_PARAMS.
      *
-     * @return the string representation of CK_PKCS5_PBKD2_PARAMS
+     * @return the string representation of CK_X9_42_DH1_DERIVE_PARAMS
      */
     public String toString() {
         StringBuilder sb = new StringBuilder();
--- jdk17u/src/jdk.crypto.cryptoki/share/classes/sun/security/pkcs11/wrapper/PKCS11Constants.java	2022-10-19 11:43:16.203128248 +0200
+++ jdk17u/src/jdk.crypto.cryptoki/share/classes/sun/security/pkcs11/wrapper/PKCS11Constants.java	2022-10-19 11:43:33.835267926 +0200
@@ -1104,17 +1104,6 @@
     public static final long  CKD_BLAKE2B_384_KDF      = 0x00000019L;
     public static final long  CKD_BLAKE2B_512_KDF      = 0x0000001aL;
 
-    public static final long  CKP_PKCS5_PBKD2_HMAC_SHA1        = 0x00000001L;
-    public static final long  CKP_PKCS5_PBKD2_HMAC_GOSTR3411   = 0x00000002L;
-    public static final long  CKP_PKCS5_PBKD2_HMAC_SHA224      = 0x00000003L;
-    public static final long  CKP_PKCS5_PBKD2_HMAC_SHA256      = 0x00000004L;
-    public static final long  CKP_PKCS5_PBKD2_HMAC_SHA384      = 0x00000005L;
-    public static final long  CKP_PKCS5_PBKD2_HMAC_SHA512      = 0x00000006L;
-    public static final long  CKP_PKCS5_PBKD2_HMAC_SHA512_224  = 0x00000007L;
-    public static final long  CKP_PKCS5_PBKD2_HMAC_SHA512_256  = 0x00000008L;
-
-    public static final long  CKZ_SALT_SPECIFIED      = 0x00000001L;
-
     public static final long  CK_OTP_VALUE            = 0x00000000L;
     public static final long  CK_OTP_PIN              = 0x00000001L;
     public static final long  CK_OTP_CHALLENGE        = 0x00000002L;
@@ -1150,12 +1139,23 @@
     public static final long  CKF_HKDF_SALT_KEY    = 0x00000004L;
     */
 
+    // PBKDF2 support, used in P11Util
+    public static final long  CKZ_SALT_SPECIFIED      = 0x00000001L;
+    public static final long  CKP_PKCS5_PBKD2_HMAC_SHA1        = 0x00000001L;
+    public static final long  CKP_PKCS5_PBKD2_HMAC_GOSTR3411   = 0x00000002L;
+    public static final long  CKP_PKCS5_PBKD2_HMAC_SHA224      = 0x00000003L;
+    public static final long  CKP_PKCS5_PBKD2_HMAC_SHA256      = 0x00000004L;
+    public static final long  CKP_PKCS5_PBKD2_HMAC_SHA384      = 0x00000005L;
+    public static final long  CKP_PKCS5_PBKD2_HMAC_SHA512      = 0x00000006L;
+    public static final long  CKP_PKCS5_PBKD2_HMAC_SHA512_224  = 0x00000007L;
+    public static final long  CKP_PKCS5_PBKD2_HMAC_SHA512_256  = 0x00000008L;
+
     // private NSS attribute (for DSA and DH private keys)
     public static final long  CKA_NETSCAPE_DB         = 0xD5A0DB00L;
 
     // base number of NSS private attributes
     public static final long  CKA_NETSCAPE_BASE /*0x80000000L + 0x4E534350L*/
-                                                      = 0xCE534350L;
+    /*          now known as CKM_NSS ^        */      = 0xCE534350L;
 
     // object type for NSS trust
     public static final long  CKO_NETSCAPE_TRUST      = 0xCE534353L;
@@ -1180,4 +1180,14 @@
                                                              = 0xCE534355L;
     public static final long  CKT_NETSCAPE_VALID             = 0xCE53435AL;
     public static final long  CKT_NETSCAPE_VALID_DELEGATOR   = 0xCE53435BL;
+
+    // Additional PKCS #12 PBE key derivation algorithms defined in NSS v3.29
+    public static final long  CKM_NSS_PKCS12_PBE_SHA224_HMAC_KEY_GEN
+                                        /* (CKM_NSS + 29) */ = 0xCE53436DL;
+    public static final long  CKM_NSS_PKCS12_PBE_SHA256_HMAC_KEY_GEN
+                                        /* (CKM_NSS + 30) */ = 0xCE53436EL;
+    public static final long  CKM_NSS_PKCS12_PBE_SHA384_HMAC_KEY_GEN
+                                        /* (CKM_NSS + 31) */ = 0xCE53436FL;
+    public static final long  CKM_NSS_PKCS12_PBE_SHA512_HMAC_KEY_GEN
+                                        /* (CKM_NSS + 32) */ = 0xCE534370L;
 }
